Development Tools |

| unopkg | The new UNO package deployment tool. It comes with the office installation and can be found in the program directory of the office installation.
| uno | Tool to provide a UNO runtime environment and provide configured (deployed) or single components. This tool comes with the office installation and can be found in the program directory of the office installation.
| regmerge | Tool to merge several registry (e.g. type libraries) files into one file. Note: Since OpenOffice.org 3 it is not longer part of the SDK but it comes directly with the office as part of the ure.
| regview | Tool to view the content of a registry file in a human readable manner. Special support for type library nodes. Note: Since OpenOffice.org 3 it is not longer part of the SDK but it comes directly with the office as part of the ure.
| idlc | The UNOIDL compiler, generates a common binary type library format as base for all codemaker tools and the UNO runtime type library.
| cppumaker | Tool for generating C++ code for the UNOIDL types stored in a type library.
| javamaker | Tool for generating Java class files for the UNOIDL types stored in a type library.
| climaker | Tool for generating CLI assemblies for the UNOIDL types stored in a type library (windows only).
| uno-skeletonmaker | Tool for dumping type definitions on stdout or generating complete code skeletons for Java/C++.
| regcomp | A simple UNO component registration tool.
| regmerge | Tool to merge several registry (e.g. type libraries) files into one file.
| regview | Tool to view the content of a registry file in a human readable manner. Special support for type library nodes.
| autodoc | Tool to generate javadoc-like documentation for C/C++ and UNOIDL files.

unopkg |

'unopkg' is a tool for easy deployment of UNO packages in an existing office installation. UNO packages are UNO components (single libraries or Jar files or more complex zip files that contains one or more libraries| Jar files, type libraries and configuration items), scripts and OpenOffice.org %PRODUCT_RELEASE% Basic libraries as zip package. 'unopkg' is not part of the SDK but comes with the office directly and is a development tool as well as an end user tool to deploy extension into an office installation.

More details concerning deployment and this tool can be find in the Developer's Guide: Extension Manager - unopkg.

Note: This tool works only in the <office>/program directory!

Usage:

> `unopkg add <options> package-path...
> unopkg remove <options> package-name...
> unopkg list <options> package-name...
> unopkg reinstall <options>
> unopkg gui
> unopkg -V
> unopkg -h
> `

Sub-commands:

`add` | add packages
`remove` | remove packages by name
`reinstall` | export feature: reinstall all deployed packages
`list` | list information about deployed packages
`gui` | raise Package Manager Graphical User Interface (GUI)

Options:

`-h, --help` | show this help on the command line
`-V, --version` | shows version information
`-v, --verbose` | dump verbose output to stdout
`-f, --force` | force overwriting existing packages
`--log-file <file>` | custom log file; default: <cache-dir>/log.txt.
`--shared` | expert feature: operate on shared installation deployment context; run only when no concurrent Office process(es) are running!
`--deployment-context <context>` | expert feature: explicit deployment context

uno |

The UNO-starter is for running a component or service process, and providing a runtime environment. Raising a component might look like this

`[c:\] uno.exe -c MyComponent -l mycomp.dll -r myregistry.rdb -- foo bar`

or

`[c:\] uno.exe -s foo.bar.FooBarService -r myregistry.rdb -- foo bar`

The starter loads the component and instantiates it. The component must export the interface com.sun.star.lang.XMain:

`interface XMain : com::sun::star::uno::XInterface
{
/** This method is called to run the component.
@param aArguments command line arguments
@return process error code to be returned to system
*/
long run( [in] sequence< string > arguments );
};`

Method run() will be called and returns the error code given, back to the system. If the uno starter is executed with the -u (URL) option, then XInitialization is used instead of XMain. The -u option is described later.

Usage:

> `uno (-c<ComponentImplementationName> -l <LocationUrl> | -s <ServiceName>)
> [-ro <ReadOnlyRegistry1>] [-ro <ReadOnlyRegistry2>] ... [-rw <ReadWriteRegistry>]
> [-u uno:(socket[,host=<HostName>][,port=<nnn>]|pipe[,name=<PipeName>]);iiop|urp;<Name>
> [--singleaccept] [--singleinstance]]
> [-- <Argument1 Argument2 ...>]`

Options:

`<HostName>` | Specifying a host name might be necessary to distinguish the network interface to be used,if a machine is part of two networks.
`<PipeName>` | Name of a named pipe.
`<Name>` | Identifier for demanded called component instances.
`<Registries>` | The optional `<Registries>` (e.g., c:\myreg.rdb) are used by the ServiceManager. The ro ones are opened for reading only; whereas, a single rw one will be opened for reading and writing. If the rw one does not exist, then it may be created. Components may read and write to store their persistent state.
`--singleaccept` | The uno starter will accept one connection, provide the component instance and die.
`--singleinstance` | The uno starter will accept any number of connections, but will provide the same single component instance any time instead of creating a new instance for each connection.

Service com.sun.star.bridge.UnoUrlResolver

You can easily connect to a server started with the `-u (url)` option by using this service, giving the same url to resolve. The service provides you an instance from remote.

idlc |

'idlc' is the UNOIDL compiler. It is a full featured compiler used to check UNODL type definitions and transform valid type definitions into a binary type library format, which is later used by all codemaker tools. It is also used as a dynamic type library for UNO at runtime.
You can find a syntax description for UNOIDL here.

Usage:

> `idlc [-options] file_1 ... file_n | @<filename>`

`file_1 ... file_n` | specifies one or more idl files. Only files with the extension '.idl' are valid.
`@<filename>` | filename specifies the name of a command file.

Options:

`-O<path>` | path describes the output directory. The generated output is a registry file with the same name as the idl input file.
`-I<path>` | path specifies a directory where included files that will be searched by the preprocessor are located. Multiple directories can be combined with ';'.
`-D<name>` | name defines a macro for the preprocessor.
`-C` | generates complete type information, including additional service information and documentation.
`-h|?` | print this help message and exit.

cppumaker |

The 'cppumaker' generates a C++ representation for idl types. The cppumaker works on a typelibrary, which is generated by the UNOIDL compiler ( idlc). It generates the output for all specified types and for all types the specified types depend on.

Usage:

> `cppumaker [-options] file_1 ... file_n`

Options:

`-O<path>` | path describes the root directory for the generated output. The output directory tree is generated under this directory.

`-T<name>
|-T<t1>;<t2>...`

name specifies a type or a list of types. The output for this type and all dependent types are generated. If no '-T' option is specified, then output for all types is generated. It is also possible to use a wildcard 'xy.*' to generate a complete module inclusive all subdirectories. The use of '-T*' is equivalent to no '-T' option. Example: 'com.sun.star.uno.XInterface' or 'com.sun.star.uno.*' are valid types.

`-B<name>` | name specifies the base node. All types are searched under this node. Default is the root '/' of the registry files.
`-L` | UNO type functions are generated lightweight, that means only the name and typeclass are given and everything else is retrieved from the type library dynamically. The default is that UNO type functions provides enough type information for boostrapping C++. '-L' should be the default for external components.
`-C` | UNO type functions are generated comprehensive that means all necessary information is available for bridging the type in UNO.
`-G` | generate only target files which do not exist.
`-Gc` | generate only target files whose content will be changed.
`-X<name>` | extra types, which are not be taken into account for generation.

javamaker |

The 'javamaker' generates the appropriate Java class file for each idl type. The javamaker works on a typelibrary which is generated by the UNOIDL compiler ( idlc). It generates the output for all specified types and for all types the specified types depend on.

Usage:

> `javamaker [-options] file_1 ... file_n -Xfile_n+1 -Xfile_n+2`

Options:

`-O<path>` | path describes the root directory for the generated output. The output directory tree is generated under this directory.

`-T<name>|-T<t1>;<t2>...`

name specifies a type or a list of types. The output for this type and all dependent types are generated. If no '-T' option is specified, then output for all types is generated. It is also possible to use a wildcard 'xy.*' to generate a complete module inclusive all subdirectories. The use of '-T*' is equivalent to no '-T' option. Example: 'com.sun.star.uno.XInterface' or 'com.sun.star.uno.*' are valid types.

`-B<name>` | name specifies the base node. All types are searched under this node. Default is the root '/' of the registry files.
`-nD` | no dependent types are generated.
`-G` | generate only target files which do not exist.
`-Gc` | generate only target files whose content will be changed.
`-X<name>` | extra types, which will not be taken into account for generation.

climaker |

The 'climaker' (windows only) generates the appropriate CLI assemblies file for each idl type. The climaker works on a typelibrary which is generated by the UNOIDL compiler ( idlc). It generates the output for all specified types and for all types the specified types depend on.

Usage:

> `climaker <switches> [registry-file-1 registry-file-2 ...]`

Options:

`-O, --out <output_file>` | output assembly file; defaults to cli_unotypes.dll if more than one registry-file is given, else <registry-file>.dll
`-T, --types <type1[;type2;...]>` | types to be generated (if none is given, then all types of given registries are emitted
`-X, --extra <rdb-file>>` | additional rdb to saturate referenced types in given registry file(s); these types will not be emitted into the output assembly file
`-r, --reference <assembly-file>` | reference metadata from assembly file
`-k, --keyfile` | keyfile needed for strong name
`--assembly-version <version>` | sets assembly version
`--assembly-description <text>` | sets assembly description text
`--assembly-product <text>` | sets assembly product name
`--assembly-company <text>` | sets assembly company
`--assembly-copyright <text>` | sets assembly copyright
`--assembly-trademark <text>` | sets assembly trademark
`-v, --verbose` | verbose output to stdout
`-h, --help` | this message

Example: `climaker --out cli_mytypes.dll --reference cli_uretypes.dll --extra types.rdb mytypes.rdb`

uno-skeletonmaker |

The 'uno-skeletonmaker' is a tool to simplify the UNO component development. It has different modes, from simply dumping code definitions for different languages on stdout up to generating complete code skeletons. The generation of code skeletons support common component skeletons as well as specialized skeletons for special service provider interfaces.

Usage:

> `uno-skeletonmaker (-env:INIFILENAME=<url> | -env:UNO_TYPES=<url>) dump [<options>] -t <type> ...
> uno-skeletonmaker (-env:INIFILENAME=<url> | -env:UNO_TYPES=<url>) component [<options>] -n <name> -t <type> ...
> uno-skeletonmaker (-env:INIFILENAME=<url> | -env:UNO_TYPES=<url>) calc-add-in [<options>] -n <name> -t <add-in_service>
> uno-skeletonmaker (-env:INIFILENAME=<url> | -env:UNO_TYPES=<url>) add-on [<options>] -n <name> -p <protocol_name:command,...> uno-skeletonmaker -V, --version
> uno-skeletonmaker -h, --help
> `

Sub-commands:

`dump` | dump declarations on stdout (e.g. constructors, methods, type mapping for properties) or complete method bodies with method forwarding.
`component` | generates language specific code skeleton files using the implementation name as the file and class name
`calc-add-in` | generates a language specific code skeleton for a Calc Add-Ins using the implementation name as the file and class name. A service type is necessary, referencing an interface which defines the new add-in functions.
`add-on` | generates a language specific code skeleton for an add-on compnent using the implementation name as the file and class name. The protocol name(s) and the corresponding command(s) have to be specified with the '-p' option.

Options:

`-env:INIFILENAME=<url>` | url specifies a URL to an UNO ini|rc file of an existing UNO environment (URE, office installation).
`-env:UNO_TYPES=<url>` | url specifies a binary type library file. It can be a space separated list of urls.
`-a, --all` | list all interface methods, not only the direct ones
`--(java4|java5|cpp)` | select the target language --java4 generate output for Java 1.4 or earlier --java5 generate output for Java 1.5 or later (is currently the default) --cpp generate output for C++
`-sn, --shortnames` | using namespace abbreviation 'css:': for '::com::sun::star::', only valid for sub-command 'dump' and target language 'cpp'. It is default for the sub-command 'component'.
`--propertysetmixin` | the generated skeleton implements the cppu::PropertySetMixin helper if a referenced new style service specifies an interface which provides attributes (directly or inherited).
`-lh --licenseheader` | generates a default OpenOffice.org LGPL license header at the beginning of a component source file. This option is taken into account in 'component' mode only and if -o is unequal 'stdout'.

`-bc
--backward-compatible`

specifies that the generated calc add-in is backward compatible to older office versions and implement the former required add-in interfaces where the implementation is mapped on the new add-in configuration. In this case the config schema needs to be bundled with the extension add-in as well. Default is a minimal add-in component skeleton based on the add-in configuration coming with the office since OO.org 2.0.4.

`-o <path>` | path specifies an existing directory where the output files are generated to, only valid for sub-command 'component'. If path=stdout the generated code is generated on standard out instead of a file.
`-l <file>` | specifies a binary type library (can be used more than once). The type library is integrated as an additional type provider in the bootstrapped type system.
`-n <name>` | specifies an implementation name for the component (used as classname, filename and package|namespace name). In 'dump' mode it is used as classname (e.g. "MyBase::", C++ only) to generate method bodies not inline.
`-d <name>` | specifies a base classname or a delegator. In 'dump' mode it is used as a delegator to forward methods. It can be used as '<name>::' for base forwarding, or '<name>->|.' for composition. Using "_" means that a default bodies with default return values are dumped.
`-t <name>` | specifies an UNOIDL type name, e.g. com.sun.star.text.XText (can be used more than once).
`-p <protocol:cmd(s)>` | specifies an add-on protocol name and the corresponding command names, where the commands are a ',' separated list of unique commands. This option is only valid for add-ons.
`-V, --version` | print version number and exit.
`-h, --help` | print this help and exit.

regcomp |

'regcomp' is a tool to register|revoke external UNO components into|from a registry which is used in a UNO environment.

Usage:

> `regcomp -revoke [-br<registryfile>] -r <registryfile> -c <locationUrl>[-l<componentLoaderName>]`

Options:

`-register|revoke` | register means that the components will be installed and revoke means that they will be removed.
`-br<registryfile>` | the name of the registry used for bootstrapping the program. If the bootstrap registry is specified and has the same name as the registration registry, '-r' is optional.
`-r<registryfile>` | the name of the registry (will be created if it does not exist) where the component should be registered.
`-c<locationUrls>` | the location of a component (DLL, Class name, or an url of a jar file) or a list of urls separated by ';'s. Note that, if a list of urls is specified, the components must all need the same loader.
`-l<componentLoaderName>` | the name of the needed loader, if no loader is specified the 'com.sun.star.loader.SharedLibrary' is used. Supported loaders: 'com.sun.star.loader.SharedLibrary' | 'com.sun.star.loader.Java'.

regmerge |

'regmerge' is a small tool to merge different registry files under a specified key into another registry file. If a value already exists in the target file the value is overwritten by the value of the source file.

Usage:

> `regmerge [-v|--verbose] <mergefile> <mergeKeyName> <regfile_1> ... <regfile_n>`

Options:

`-v|--verbose` | verbose output on stdout.
`<mergefile>` | specifies the merged registry file. If this file doesn't exist, it is created.
`<mergeKeyName>` | specifies the merge key, everything is merged under this key. If this key doesn't exist, it is created.
`<regfile_1> ... <regfile_n>` | specifies one or more registry files that are merged.

regview |

'regview' is a tool to show the contents of a registry file. The tool dumps the hierarchical structure and the values of the nodes in a human readable manner to stdout.

Usage:

> `regview <registryfile> [<keyName>]`

Options:

-br<registryfile> | the name of the registry whose contents should be viewed.
`<keyName>` | the name of a registry key. The name must be fully qualified; for example, '/' means the root key and '/UCR/com/sun/star/uno/XInterface' shows the type specification of the XInterface type. If no key is specified, the tool dumps the whole content of the registry file.

autodoc |

The 'autodoc' tool is used for creating javadoc-like documentation from C++ and UNOIDL source code.

There are some conventions to follow when documenting C++- or UNOIDL-sourcecode. See also the UNOIDL Documentation Guidelines.
If you are not familiar with these, but do know javadoc: For simple C++ sourcecode documentation, using javadoc-style comments will work.

Usage:

> `autodoc [ -v <VerboseNr> ] [ -name "<TitleForTheDocu>" ] -html <OutputDirectory> -lg <SourcecodeLanguage>
> { [ -p <ProjectName> <ProjectRootDirectory> ] -t <SourceTree>* | -d <SourceDirectory>* | -f <SourceFile>* }*`

Options:

`-v <VerboseNr>` | <VerboseNr> == 5 displays the parsed source code tokens, so you can locate which piece caused an parsing error. <VerboseNr> == 2 displays not only the parsed source code, but also the comments. This option must be the first one, if it is used.
`-name "<Title>"` | <Title> occurs as the title of the start page of the HTML output. If this option is omitted, a default title is created.
`-html <OutputDirectory>` | specifies the root directory where the HTML output is created. Autodoc does not remove old files there, though it overwrites them.
`-lg <SourcecodeLanguage>` | Possible values are: c++ | idl. This also specifies which files will be parsed: "c++" parses all files with the endings .hxx and .h, "idl" parses all files with the ending '.idl' . To change this behaviour, see at option `-f`.

`-p <ProjectName> <ProjectDirectory>`

this option can be used to divide large code bases into different projects.
<ProjectName> gives a user-defined name for the project.
<ProjectDirectory> is the root to which all paths, given with the following options `-t,-d` and `-f`, are relative.
This option can be omitted when there are no projects and all paths in the following options are relative to the working directory.
The "{ ... }*" around the options `-p,-t,-d,-f` indicates, that this whole block of options can be repeated, each block starting with a new `-p`.

`-t <SourceTree>` | specifies that all files in the directory <SourceTree> and it's subdirectories are parsed, where the file ending matches the option `-lg`. There can be given multiple directories after one `-t` option. All relative paths are relative to the project-rootdirectory, given with the `-p` option.
`-d <SourceDirectory>` | Specifies that all files in th directory <SourceDirectory>, but NOT it's subdirectories, are parsed, where the file ending matches the option `-lg`. There can be multiple directories given after one `-d` option. All relative paths are relative to the project-rootdirectory, given with the `-p` option.
`-f <SourceFile>` | parses the given file. The ending does not have to match the `-lg` option. There can be multiple files given after one `-f` option. All relative paths are relative to the project-rootdirectory, given with the `-p` option.

Remark: The sequence of options matters! Use them in the order given in the "Usage"-paragraph.

Copyright © 2010, Oracle and/or its affiliates. All rights reserved. Oracle and Java are registered trademarks of Oracle and/or its affiliates. Other names may be trademarks of their respective owners.